﻿Imports j2associates.Tools

Public Class Form1

    Private Enum WindowsFormEvents As Integer
        Maximizing = 0
        Maximized
        Minimizing
        Minimized
        Restoring
        Restored
    End Enum 'WindowsFormEvents

    Private WithEvents _NativeWindowListener As WindowsFormNativeWindowListener

    ' Cannot use dictionary because duplicate entries.
    Private _RichTextBoxItems As List(Of String)
    Private _RichTextBoxEvents As List(Of WindowsFormEvents)

    Private _RestoreColor As Color = Color.LimeGreen
    Private _MaximizeColor As Color = Color.Red
    Private _MinimizeColor As Color = Color.Blue

    ' Use to offset for additional effect.
    Private _RestoreSpacer As String = String.Empty ' Space(2)
    Private _MaximizeSpacer As String = String.Empty ' Space(0)
    Private _MinimizeSpacer As String = String.Empty ' Space(4)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        _NativeWindowListener = New WindowsFormNativeWindowListener(Me)
        _RichTextBoxItems = New List(Of String)
        _RichTextBoxEvents = New List(Of WindowsFormEvents)
    End Sub 'Form1_Load

    Private Sub NativeWindowListener_WindowMaximized(ByVal sender As Object, ByVal e As j2associates.Tools.WindowStateChangedEventArgs) Handles _NativeWindowListener.WindowMaximized
        If Me.chkPopMessages.Checked Then
            MsgBox(String.Format("OldBounds: {0}{1}OldVisible: {2}{1}OldWindowState: {3}{1}{1}NewBounds: {4}{1}NewVisible: {5}{1}NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString))
        End If
        If Me.chkWriteToConsole.Checked Then
            Console.WriteLine(String.Format("{1}OldBounds: {0}{1}OldVisible: {2}{1}OldWindowState: {3}{1}{1}NewBounds: {4}{1}NewVisible: {5}{1}NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString))
        End If
        UpdateRichTextBox(WindowsFormEvents.Maximized, Color.Red, String.Format("{7}Maximized - OldBounds: {0}, OldVisible: {2}, OldWindowState: {3}, NewBounds: {4}, NewVisible: {5}, NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString, _MaximizeSpacer))
    End Sub 'NativeWindowListener_WindowMaximized

    Private Sub NativeWindowListener_WindowMaximizing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles _NativeWindowListener.WindowMaximizing
        e.Cancel = (MessageBox.Show("Cancel Maximizing Event?", "Confirm Cancellation", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) = Windows.Forms.DialogResult.Yes)
        UpdateRichTextBox(WindowsFormEvents.Maximizing, Color.Red, String.Format("{2}Maximizing - Cancelled: {0}{1}", e.Cancel, Environment.NewLine, _MaximizeSpacer))
    End Sub 'NativeWindowListener_WindowMaximizing

    Private Sub NativeWindowListener_WindowMinimized(ByVal sender As Object, ByVal e As j2associates.Tools.WindowStateChangedEventArgs) Handles _NativeWindowListener.WindowMinimized
        If Me.chkPopMessages.Checked Then
            MsgBox(String.Format("OldBounds: {0}{1}OldVisible: {2}{1}OldWindowState: {3}{1}{1}NewBounds: {4}{1}NewVisible: {5}{1}NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString))
        End If
        If Me.chkWriteToConsole.Checked Then
            Console.WriteLine(String.Format("{1}OldBounds: {0}{1}OldVisible: {2}{1}OldWindowState: {3}{1}{1}NewBounds: {4}{1}NewVisible: {5}{1}NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString))
        End If
        UpdateRichTextBox(WindowsFormEvents.Minimized, Color.LimeGreen, String.Format("{7}Minimized - OldBounds: {0}, OldVisible: {2}, OldWindowState: {3}, NewBounds: {4}, NewVisible: {5}, NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString, _MinimizeSpacer))
    End Sub 'NativeWindowListener_WindowMinimized

    Private Sub NativeWindowListener_WindowMinimizing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles _NativeWindowListener.WindowMinimizing
        e.Cancel = (MessageBox.Show("Cancel Minimizing Event?", "Confirm Cancellation", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) = Windows.Forms.DialogResult.Yes)
        UpdateRichTextBox(WindowsFormEvents.Minimizing, Color.LimeGreen, String.Format("{2}Minimizing - Cancelled: {0}{1}", e.Cancel, Environment.NewLine, _MinimizeSpacer))
    End Sub 'NativeWindowListener_WindowMinimizing

    Private Sub NativeWindowListener_WindowRestored(ByVal sender As Object, ByVal e As j2associates.Tools.WindowStateChangedEventArgs) Handles _NativeWindowListener.WindowRestored
        If Me.chkPopMessages.Checked Then
            MsgBox(String.Format("OldBounds: {0}{1}OldVisible: {2}{1}OldWindowState: {3}{1}{1}NewBounds: {4}{1}NewVisible: {5}{1}NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString))
        End If
        If Me.chkWriteToConsole.Checked Then
            Console.WriteLine(String.Format("{1}OldBounds: {0}{1}OldVisible: {2}{1}OldWindowState: {3}{1}{1}NewBounds: {4}{1}NewVisible: {5}{1}NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString))
        End If
        UpdateRichTextBox(WindowsFormEvents.Restored, Color.Blue, String.Format("{7}Restored - OldBounds: {0}, OldVisible: {2}, OldWindowState: {3}, NewBounds: {4}, NewVisible: {5}, NewWindowState: {6}{1}", e.OldBounds.ToString, Environment.NewLine, e.OldVisible, e.OldWindowState, e.NewBounds.ToString, e.NewVisible, e.NewWindowState.ToString, _RestoreSpacer))
    End Sub 'NativeWindowListener_WindowRestored

    Private Sub NativeWindowListener_WindowRestoring(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles _NativeWindowListener.WindowRestoring
        e.Cancel = (MessageBox.Show("Cancel Restoring Event?", "Confirm Cancellation", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) = Windows.Forms.DialogResult.Yes)
        UpdateRichTextBox(WindowsFormEvents.Restoring, Color.Blue, String.Format("{2}Restoring - Cancelled: {0}{1}", e.Cancel, Environment.NewLine, _RestoreSpacer))
    End Sub 'NativeWindowListener_WindowRestoring

    Private Sub UpdateRichTextBox(ByVal formEvent As WindowsFormEvents, ByVal selectionColor As Color, ByVal text As String)
        Me.rtbResults.Text &= text
        _RichTextBoxItems.Add(text)
        _RichTextBoxEvents.Add(formEvent)
        HighlightRichTextBox()
        If True Then Return

        ' Selection start resets to zero after appending text.
        Dim selectionStart As Integer = Me.rtbResults.TextLength
        Me.rtbResults.Text &= text
        selectionStart = Me.rtbResults.Find(text.Trim, RichTextBoxFinds.Reverse)
        'Me.rtbResults.SelectionStart = selectionStart
        'Me.rtbResults.SelectionLength = Me.rtbResults.TextLength - selectionStart
        Me.rtbResults.SelectionColor = selectionColor
    End Sub 'UpdateRichTextBox

    Private Sub HighlightRichTextBox()
        ' Save current selection.
        Dim startIndex As Integer = 0, selectionStart As Integer = Me.rtbResults.SelectionStart, selectionLength As Integer = Me.rtbResults.SelectionLength

        ' Highlight text.
        For index As Integer = 0 To _RichTextBoxItems.Count - 1
            startIndex = Me.rtbResults.Find(_RichTextBoxItems(index).Trim, startIndex, RichTextBoxFinds.MatchCase)
            If startIndex > -1 Then
                Select Case _RichTextBoxEvents(index)
                    Case WindowsFormEvents.Maximized, WindowsFormEvents.Maximizing
                        Me.rtbResults.SelectionColor = _MaximizeColor
                    Case WindowsFormEvents.Minimized, WindowsFormEvents.Minimizing
                        Me.rtbResults.SelectionColor = _MinimizeColor
                    Case WindowsFormEvents.Restored, WindowsFormEvents.Restoring
                        Me.rtbResults.SelectionColor = _RestoreColor
                End Select
            End If
            startIndex += _RichTextBoxItems(index).Trim.Length
        Next

        ' Restore the original selection.
        Me.rtbResults.Select(selectionStart, selectionLength)
    End Sub 'HighlightRichTextBox

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        HighlightPhrase(Me.rtbResults, "Maximizing", Color.Red)
        HighlightPhrase(Me.rtbResults, "Minimizing", Color.Blue)
    End Sub

    Private Sub HighlightPhrase(ByVal rtb As RichTextBox, ByVal phrase As String, ByVal highlightColor As Color)
        ' Save current selection.
        Dim selectionStart As Integer = rtb.SelectionStart
        Dim selectionLength As Integer = rtb.SelectionLength

        ' Highlight phrase.
        Dim phraseLength As Integer = phrase.Length
        Dim start As Integer = 0
        While rtb.Find(phrase, start, RichTextBoxFinds.WholeWord) >= 0
            rtb.SelectionColor = highlightColor
            'rtb.SelectionBackColor = highlightColor;
            start += phraseLength
        End While

        ' Restore the original selection.
        rtb.[Select](selectionStart, selectionLength)
    End Sub

End Class 'Form1
